;/*****************************************************************************
; * @file:    startup_LPC8N04.s
; * @purpose: CMSIS Cortex-M0 Core Device Startup File
; *           LPC8N04
; * @version: 1.0
; * @date:    2018-6-21
; *----------------------------------------------------------------------------
; *
; Copyright 1997-2016 Freescale Semiconductor, Inc.
; Copyright 2016-2018 NXP
;
; SPDX-License-Identifier: BSD-3-Clause
;
; The modules in this file are included in the libraries, and may be replaced
; by any user-defined modules that define the PUBLIC symbol _program_start or
; a user defined start symbol.
; To override the cstartup defined in the library, simply add your modified
; version to the workbench project.
;
; The vector table is normally located at address 0.
; When debugging in RAM, it can be located in RAM, aligned to at least 2^6.
; The name "__vector_table" has special meaning for C-SPY:
; it is where the SP start value is found, and the NVIC vector
; table register (VTOR) is initialized to this address if != 0.
;
; Cortex-M version
;

        MODULE  ?cstartup

        ;; Forward declaration of sections.
        SECTION CSTACK:DATA:NOROOT(3)

        SECTION .intvec:CODE:NOROOT(2)

        EXTERN  __iar_program_start
        EXTERN  SystemInit
        PUBLIC  __vector_table
        PUBLIC  __vector_table_0x1c
        PUBLIC  __Vectors
        PUBLIC  __Vectors_End
        PUBLIC  __Vectors_Size

        DATA

__vector_table
        DCD     sfe(CSTACK)
        DCD     Reset_Handler

        DCD     NMI_Handler
        DCD     HardFault_Handler
        DCD     0
        DCD     0
        DCD     0
__vector_table_0x1c
        DCD     0
        DCD     0
        DCD     0
        DCD     0
        DCD     SVC_Handler
        DCD     0
        DCD     0
        DCD     PendSV_Handler
        DCD     SysTick_Handler

        ; External Interrupts
        DCD     PIO0_0_IRQHandler  ; PIO0_0 Start Logic Interrupt
        DCD     PIO0_1_IRQHandler  ; PIO0_1 Start Logic Interrupt
        DCD     PIO0_2_IRQHandler  ; PIO0_2 Start Logic Interrupt
        DCD     PIO0_3_IRQHandler  ; PIO0_3 Start Logic Interrupt
        DCD     PIO0_4_IRQHandler  ; PIO0_4 Start Logic Interrupt
        DCD     PIO0_5_IRQHandler  ; PIO0_5 Start Logic Interrupt
        DCD     PIO0_6_IRQHandler  ; PIO0_6 Start Logic Interrupt
        DCD     PIO0_7_IRQHandler  ; PIO0_7 Start Logic Interrupt
        DCD     PIO0_8_IRQHandler  ; PIO0_8 Start Logic Interrupt
        DCD     PIO0_9_IRQHandler  ; PIO0_9 Start Logic Interrupt
        DCD     PIO0_10_IRQHandler  ; PIO0_10 Start Logic Interrupt
        DCD     RFFIELD_IRQHandler  ; NFC Access Start Logic Interrupt
        DCD     RTCPWREQ_IRQHandler  ; RTC Wakeup Request Start Logic Interrupt
        DCD     NFC_IRQHandler  ; NFC Read/Write Interrupt
        DCD     RTC_IRQHandler  ; RTC Wakeup Interrupt
        DCD     I2C0_IRQHandler  ; I2C0 Interrupt
        DCD     CTIMER0_IRQHandler  ; 16-bit Timer 0 Interrupt
        DCD     PMUFLD_IRQHandler  ; RF Power Detection Interrupt
        DCD     CTIMER1_IRQHandler  ; 32-bit Timer 0 Interrupt
        DCD     PMUBOD_IRQHandler  ; Brown Out Detection Interrupt
        DCD     SSP0_IRQHandler  ; SSP0 Interrupt
        DCD     TSEN_IRQHandler  ; Temperature Sensor Interrupt
        DCD     C2D_IRQHandler  ; Capacitance-to-Digital converter Interrupt
        DCD     Reserved39_IRQHandler  ; Reserved interrupt
        DCD     I2D_IRQHandler  ; Current-to-Digital converter Interrupt
        DCD     ADCDAC_IRQHandler  ; Analog-to-Digital/Digital-to-Analog converter Interrupt
        DCD     WDT_IRQHandler  ; Watchdog Timer Interrupt
        DCD     FLASH_IRQHandler  ; FLASH memory Interrupt
        DCD     EEPROM_IRQHandler  ; EEPROM memory Interrupt
        DCD     Reserved45_IRQHandler  ; Reserved interrupt
        DCD     Reserved46_IRQHandler  ; Reserved interrupt
        DCD     PIO0_IRQHandler  ; GPIO Port 0 Interrupt
__Vectors_End

__Vectors       EQU   __vector_table
__Vectors_Size 	EQU 	__Vectors_End - __Vectors


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Default interrupt handlers.
;;
        THUMB

        PUBWEAK Reset_Handler
        SECTION .text:CODE:REORDER:NOROOT(2)
Reset_Handler
        LDR     r0, =SystemInit
        BLX     r0
        LDR     r0, =__iar_program_start
        BX      r0

        PUBWEAK NMI_Handler
        SECTION .text:CODE:REORDER:NOROOT(1)
NMI_Handler
        B .

        PUBWEAK HardFault_Handler
        SECTION .text:CODE:REORDER:NOROOT(1)
HardFault_Handler
        B .

        PUBWEAK SVC_Handler
        SECTION .text:CODE:REORDER:NOROOT(1)
SVC_Handler
        B .

        PUBWEAK PendSV_Handler
        SECTION .text:CODE:REORDER:NOROOT(1)
PendSV_Handler
        B .

        PUBWEAK SysTick_Handler
        SECTION .text:CODE:REORDER:NOROOT(1)
SysTick_Handler
        B .

        PUBWEAK PIO0_0_IRQHandler
        PUBWEAK PIO0_0_DriverIRQHandler
        SECTION .text:CODE:REORDER:NOROOT(2)
PIO0_0_IRQHandler
        LDR     R0, =PIO0_0_DriverIRQHandler
        BX      R0
        PUBWEAK PIO0_1_IRQHandler
        PUBWEAK PIO0_1_DriverIRQHandler
        SECTION .text:CODE:REORDER:NOROOT(2)
PIO0_1_IRQHandler
        LDR     R0, =PIO0_1_DriverIRQHandler
        BX      R0
        PUBWEAK PIO0_2_IRQHandler
        PUBWEAK PIO0_2_DriverIRQHandler
        SECTION .text:CODE:REORDER:NOROOT(2)
PIO0_2_IRQHandler
        LDR     R0, =PIO0_2_DriverIRQHandler
        BX      R0
        PUBWEAK PIO0_3_IRQHandler
        PUBWEAK PIO0_3_DriverIRQHandler
        SECTION .text:CODE:REORDER:NOROOT(2)
PIO0_3_IRQHandler
        LDR     R0, =PIO0_3_DriverIRQHandler
        BX      R0
        PUBWEAK PIO0_4_IRQHandler
        PUBWEAK PIO0_4_DriverIRQHandler
        SECTION .text:CODE:REORDER:NOROOT(2)
PIO0_4_IRQHandler
        LDR     R0, =PIO0_4_DriverIRQHandler
        BX      R0
        PUBWEAK PIO0_5_IRQHandler
        PUBWEAK PIO0_5_DriverIRQHandler
        SECTION .text:CODE:REORDER:NOROOT(2)
PIO0_5_IRQHandler
        LDR     R0, =PIO0_5_DriverIRQHandler
        BX      R0
        PUBWEAK PIO0_6_IRQHandler
        PUBWEAK PIO0_6_DriverIRQHandler
        SECTION .text:CODE:REORDER:NOROOT(2)
PIO0_6_IRQHandler
        LDR     R0, =PIO0_6_DriverIRQHandler
        BX      R0
        PUBWEAK PIO0_7_IRQHandler
        PUBWEAK PIO0_7_DriverIRQHandler
        SECTION .text:CODE:REORDER:NOROOT(2)
PIO0_7_IRQHandler
        LDR     R0, =PIO0_7_DriverIRQHandler
        BX      R0
        PUBWEAK PIO0_8_IRQHandler
        PUBWEAK PIO0_8_DriverIRQHandler
        SECTION .text:CODE:REORDER:NOROOT(2)
PIO0_8_IRQHandler
        LDR     R0, =PIO0_8_DriverIRQHandler
        BX      R0
        PUBWEAK PIO0_9_IRQHandler
        PUBWEAK PIO0_9_DriverIRQHandler
        SECTION .text:CODE:REORDER:NOROOT(2)
PIO0_9_IRQHandler
        LDR     R0, =PIO0_9_DriverIRQHandler
        BX      R0
        PUBWEAK PIO0_10_IRQHandler
        PUBWEAK PIO0_10_DriverIRQHandler
        SECTION .text:CODE:REORDER:NOROOT(2)
PIO0_10_IRQHandler
        LDR     R0, =PIO0_10_DriverIRQHandler
        BX      R0
        PUBWEAK RFFIELD_IRQHandler
        PUBWEAK RFFIELD_DriverIRQHandler
        SECTION .text:CODE:REORDER:NOROOT(2)
RFFIELD_IRQHandler
        LDR     R0, =RFFIELD_DriverIRQHandler
        BX      R0
        PUBWEAK RTCPWREQ_IRQHandler
        PUBWEAK RTCPWREQ_DriverIRQHandler
        SECTION .text:CODE:REORDER:NOROOT(2)
RTCPWREQ_IRQHandler
        LDR     R0, =RTCPWREQ_DriverIRQHandler
        BX      R0
        PUBWEAK NFC_IRQHandler
        PUBWEAK NFC_DriverIRQHandler
        SECTION .text:CODE:REORDER:NOROOT(2)
NFC_IRQHandler
        LDR     R0, =NFC_DriverIRQHandler
        BX      R0
        PUBWEAK RTC_IRQHandler
        PUBWEAK RTC_DriverIRQHandler
        SECTION .text:CODE:REORDER:NOROOT(2)
RTC_IRQHandler
        LDR     R0, =RTC_DriverIRQHandler
        BX      R0
        PUBWEAK I2C0_IRQHandler
        PUBWEAK I2C0_DriverIRQHandler
        SECTION .text:CODE:REORDER:NOROOT(2)
I2C0_IRQHandler
        LDR     R0, =I2C0_DriverIRQHandler
        BX      R0
        PUBWEAK CTIMER0_IRQHandler
        PUBWEAK CTIMER0_DriverIRQHandler
        SECTION .text:CODE:REORDER:NOROOT(2)
CTIMER0_IRQHandler
        LDR     R0, =CTIMER0_DriverIRQHandler
        BX      R0
        PUBWEAK PMUFLD_IRQHandler
        PUBWEAK PMUFLD_DriverIRQHandler
        SECTION .text:CODE:REORDER:NOROOT(2)
PMUFLD_IRQHandler
        LDR     R0, =PMUFLD_DriverIRQHandler
        BX      R0
        PUBWEAK CTIMER1_IRQHandler
        PUBWEAK CTIMER1_DriverIRQHandler
        SECTION .text:CODE:REORDER:NOROOT(2)
CTIMER1_IRQHandler
        LDR     R0, =CTIMER1_DriverIRQHandler
        BX      R0
        PUBWEAK PMUBOD_IRQHandler
        PUBWEAK PMUBOD_DriverIRQHandler
        SECTION .text:CODE:REORDER:NOROOT(2)
PMUBOD_IRQHandler
        LDR     R0, =PMUBOD_DriverIRQHandler
        BX      R0
        PUBWEAK SSP0_IRQHandler
        PUBWEAK SSP0_DriverIRQHandler
        SECTION .text:CODE:REORDER:NOROOT(2)
SSP0_IRQHandler
        LDR     R0, =SSP0_DriverIRQHandler
        BX      R0
        PUBWEAK TSEN_IRQHandler
        PUBWEAK TSEN_DriverIRQHandler
        SECTION .text:CODE:REORDER:NOROOT(2)
TSEN_IRQHandler
        LDR     R0, =TSEN_DriverIRQHandler
        BX      R0
        PUBWEAK C2D_IRQHandler
        PUBWEAK C2D_DriverIRQHandler
        SECTION .text:CODE:REORDER:NOROOT(2)
C2D_IRQHandler
        LDR     R0, =C2D_DriverIRQHandler
        BX      R0
        PUBWEAK Reserved39_IRQHandler
        PUBWEAK Reserved39_DriverIRQHandler
        SECTION .text:CODE:REORDER:NOROOT(2)
Reserved39_IRQHandler
        LDR     R0, =Reserved39_DriverIRQHandler
        BX      R0
        PUBWEAK I2D_IRQHandler
        PUBWEAK I2D_DriverIRQHandler
        SECTION .text:CODE:REORDER:NOROOT(2)
I2D_IRQHandler
        LDR     R0, =I2D_DriverIRQHandler
        BX      R0
        PUBWEAK ADCDAC_IRQHandler
        PUBWEAK ADCDAC_DriverIRQHandler
        SECTION .text:CODE:REORDER:NOROOT(2)
ADCDAC_IRQHandler
        LDR     R0, =ADCDAC_DriverIRQHandler
        BX      R0
        PUBWEAK WDT_IRQHandler
        PUBWEAK WDT_DriverIRQHandler
        SECTION .text:CODE:REORDER:NOROOT(2)
WDT_IRQHandler
        LDR     R0, =WDT_DriverIRQHandler
        BX      R0
        PUBWEAK FLASH_IRQHandler
        PUBWEAK FLASH_DriverIRQHandler
        SECTION .text:CODE:REORDER:NOROOT(2)
FLASH_IRQHandler
        LDR     R0, =FLASH_DriverIRQHandler
        BX      R0
        PUBWEAK EEPROM_IRQHandler
        PUBWEAK EEPROM_DriverIRQHandler
        SECTION .text:CODE:REORDER:NOROOT(2)
EEPROM_IRQHandler
        LDR     R0, =EEPROM_DriverIRQHandler
        BX      R0
        PUBWEAK Reserved45_IRQHandler
        PUBWEAK Reserved45_DriverIRQHandler
        SECTION .text:CODE:REORDER:NOROOT(2)
Reserved45_IRQHandler
        LDR     R0, =Reserved45_DriverIRQHandler
        BX      R0
        PUBWEAK Reserved46_IRQHandler
        PUBWEAK Reserved46_DriverIRQHandler
        SECTION .text:CODE:REORDER:NOROOT(2)
Reserved46_IRQHandler
        LDR     R0, =Reserved46_DriverIRQHandler
        BX      R0
        PUBWEAK PIO0_IRQHandler
        PUBWEAK PIO0_DriverIRQHandler
        SECTION .text:CODE:REORDER:NOROOT(2)
PIO0_IRQHandler
        LDR     R0, =PIO0_DriverIRQHandler
        BX      R0
PIO0_0_DriverIRQHandler
PIO0_1_DriverIRQHandler
PIO0_2_DriverIRQHandler
PIO0_3_DriverIRQHandler
PIO0_4_DriverIRQHandler
PIO0_5_DriverIRQHandler
PIO0_6_DriverIRQHandler
PIO0_7_DriverIRQHandler
PIO0_8_DriverIRQHandler
PIO0_9_DriverIRQHandler
PIO0_10_DriverIRQHandler
RFFIELD_DriverIRQHandler
RTCPWREQ_DriverIRQHandler
NFC_DriverIRQHandler
RTC_DriverIRQHandler
I2C0_DriverIRQHandler
CTIMER0_DriverIRQHandler
PMUFLD_DriverIRQHandler
CTIMER1_DriverIRQHandler
PMUBOD_DriverIRQHandler
SSP0_DriverIRQHandler
TSEN_DriverIRQHandler
C2D_DriverIRQHandler
Reserved39_DriverIRQHandler
I2D_DriverIRQHandler
ADCDAC_DriverIRQHandler
WDT_DriverIRQHandler
FLASH_DriverIRQHandler
EEPROM_DriverIRQHandler
Reserved45_DriverIRQHandler
Reserved46_DriverIRQHandler
PIO0_DriverIRQHandler
DefaultISR
        B .

        END
